<?php

namespace Freshmail\Core\AdminMenu\Pages;

use Freshmail\Core\Integrations\Integration;

class SetupWizardPage extends AbstractPage
{
  /**
   * Returns page setup data - sections and fields arrays.
   * Can't define as const var because of callbacks.
   *
   * @return array
   * @author MS
   */
  protected function getSetup(): array
  {
    return [
      'subpages' => [
        [
          'parent_slug' => 'freshmail_settings',
          'page_title' => __('Setup wizard', 'freshmail'),
          'menu_title' => __('Setup wizard', 'freshmail'),
          'capability' => 'manage_options',
          'menu_slug' => 'freshmail_setup_wizard',
          'callback' => [$this, 'renderPage'],
          'position' => null,
        ],
        [
          'parent_slug' => null,
          'page_title' => __('Unauthorized', 'freshmail'),
          'menu_title' => __('Unauthorized', 'freshmail'),
          // 'capability' => 'edit_published_posts',
          'menu_slug' => 'freshmail_unauthorized',
          'callback' => [$this, 'renderPage'],
          'position' => null,
        ]
      ],
      'sections' => $this->getIntegrationSections(),
      'fields' => $this->getIntegrationFields(),
    ];
  }

  /**
   * Renders this page
   *
   * @return void
   * @author MS
   */
  public function renderPage()
  {
    if (! current_user_can('administrator') || 'freshmail_unauthorized' === $_GET['page']) {
      include FRERSHMAIL_RESOURCES_PATH . 'views/setup-wizard/unauthorized.php';
      die();
    }

    include FRERSHMAIL_RESOURCES_PATH . 'views/setup-wizard/wizard.php';
  }
}
