<?php

namespace Freshmail\Core\AdminMenu\Pages;

class StatisticsPage extends AbstractPage
{
  private array $charts = [];
  protected function getSetup(): array
  {
    return [
      'subpages' => [
        [
          'parent_slug' => 'freshmail_settings',
          'page_title' => __('Statistics', 'freshmail'),
          'menu_title' => __('Statistics', 'freshmail'),
          'capability' => 'manage_options',
          'menu_slug' => 'freshmail_statistics',
          'callback' => [$this, 'renderPage'],
          'position' => null,
        ]
      ],
    ];
  }

  public function renderPage(): void
  {
    $data = [
      'title' => __('Statistics', 'freshmail'),
      'charts' => $this->getCharts()
    ];
    include FRERSHMAIL_RESOURCES_PATH . 'views/admin/settings/statistics.php';
  }

  public function getCharts(): array
  {
    return apply_filters('fm/admin/pages/statistics/charts/get', $this->charts);
  }
}
