<?php
/**
 * Endpoints: integrations
 * Currently this enpoint is unlisted in docs but client requested sending data there.
 *
 * @author MS
 */
namespace Freshmail\Core\Api\Endpoints;

class Integrations extends AbstractEndpoint
{
  /**
   * Sends integration request
   *
   * @param string $vendor name of vendor, eg. WordPress or WooCommerce
   * @param string $version version of vendor
   * @return array
   * @author MS
   */
  public function integrations(string $vendor, string $version): array
  {
    $data = [
      'type' => 'plugin',
      'data' => [
        'vendor' => $vendor,
        'version' => $version,
        'url' => get_home_url(),
        'ip' => empty($_SERVER['SERVER_ADDR']) ? '' : $_SERVER['SERVER_ADDR'],
      ],
    ];

    $json_payload = json_encode($data);
    $rseult = $this->call('v3/integrations', $json_payload, 'POST');
    return $rseult;
  }
}
