<?php
/**
 * Api: Endpoints manager
 *
 * @author MS
 */
namespace Freshmail\Core\Api\Submodules;

use Freshmail\Core\Api\Endpoints\Integrations;
use Freshmail\Core\Api\Endpoints\Ping;
use Freshmail\Core\Api\Endpoints\Subscriber;
use Freshmail\Core\Api\Endpoints\SubscribersList;
use Freshmail\Core\Api\Endpoints\Templates;
use Freshmail\Core\Api\Models\ApiConfig;

class EndpointsManager
{
  public ?Ping $ping = null;

  public ?SubscribersList $subscribers_list = null;

  public ?Integrations $integrations = null;

  public ?Subscriber $subscriber = null;

  public ?Templates $templates = null;

  private ?ApiConfig $api_config = null;

  public function __construct()
  {
    $this->api_config = new ApiConfig();
    $this->ping = createClass('Freshmail\Core\Api\Endpoints\Ping', [$this->api_config]);
    $this->subscribers_list = createClass('Freshmail\Core\Api\Endpoints\SubscribersList', [$this->api_config]);
    $this->integrations = createClass('Freshmail\Core\Api\Endpoints\Integrations', [$this->api_config]);
    $this->subscriber = createClass('Freshmail\Core\Api\Endpoints\Subscriber', [$this->api_config]);
    $this->templates = createClass('Freshmail\Core\Api\Endpoints\Templates', [$this->api_config]);
  }

  public function getApiConfig(): ApiConfig
  {
    return $this->api_config;
  }
}
