<?php

namespace Freshmail\FmDesigner\Integrations\WooCommerce;

use Freshmail\FmDesigner\Integrations\WooCommerce;

class EmailTemplatesConfigurator
{
  private ?WooCommerce $wc = null;

  public function __construct(WooCommerce $wc)
  {
    $this->wc = $wc;
  }

  /**
   * @filter woocommerce_email_classes 11
   */
  public function addWooCommerceEmailCustomSettings(array $emailClassList): array
  {
    foreach ($emailClassList as $emailClass) {
      add_filter(('woocommerce_settings_api_form_fields_' . $emailClass->id), [$this, 'addCustomEmailSetting'], 10, 1);
    }
    return $emailClassList;
  }

  public function addCustomEmailSetting(array $fields): array
  {
    $options = $this->wc->fmDesigner()->getTemplateRetriever()->getEmailTemplateList();

    $fields['fm_email_template'] = array(
      'title' => __('FreshMail email template', 'freshmail'),
      'description' => __('Choose the FreshMail template for this email message', 'freshmail'),
      'type' => 'select',
      'options' => $options,
      'default' => 'wc_default',
    );
    return $fields;
  }
}
