<?php

namespace Freshmail\FmDesigner\Integrations\WooCommerce\Emails;

use Freshmail\FmDesigner\FMDesigner;
use Freshmail\FmDesigner\Integrations\WooCommerce\EmailTemplatesTags;

class EmailCustomerCompletedOrder extends \WC_Email_Customer_Completed_Order
{
  private string $templateID;

  public function __construct(string $templateID, \WC_Email $defaultObject)
  {
    $this->templateID = $templateID;

    if (! empty($this->templateID)) {
      parent::__construct();
      remove_action('woocommerce_order_status_completed_notification', [$defaultObject, 'trigger' ], 10, 2);
    }
  }

  // phpcs:disable PSR1.Methods.CamelCapsMethodName.NotCamelCaps
  public function get_content_html(): string
  {
    try {
      if (! empty($this->templateID) && ! empty($this->object) && is_a($this->object, 'WC_Order')) {
        $this->placeholders = EmailTemplatesTags::getOrderTags($this->object);
        if (! empty($content = FmDesigner::getEmailTemplateHTML($this->templateID))) {
          if (! empty($content['content_reb'])) {
            return $this->format_string($content['content_reb']);
          }
        } else {
          throw new \Exception("Email template cannot be empty", 1);
        }
      }
    } catch (\Throwable $th) {
      error_log($th);
    }
    return parent::get_content_html();
  }
}
