<?php

namespace Freshmail\FmDesigner\Integrations\WooCommerce\Emails;

use Freshmail\FmDesigner\FMDesigner;
use Freshmail\FmDesigner\Integrations\WooCommerce\EmailTemplatesTags;

class EmailCustomerNewAccount extends \WC_Email_Customer_New_Account
{
  private string $templateID;

  public function __construct(string $templateID, \WC_Email $defaultObject)
  {
    $this->templateID = $templateID;

    if (! empty($this->templateID)) {
      parent::__construct();
    }
  }

  // phpcs:disable PSR1.Methods.CamelCapsMethodName.NotCamelCaps
  public function get_content_html(): string
  {
    try {
      if (! empty($this->templateID) && ! empty($this->object) && is_a($this->object, 'WP_User')) {
        $this->placeholders = array_merge(
            EmailTemplatesTags::getCustomerTags($this->object),
            EmailTemplatesTags::getNewAccountTags($this)
        );
        if (! empty($content = FmDesigner::getEmailTemplateHTML($this->templateID))) {
          if (! empty($content['content_reb'])) {
            return $this->format_string($content['content_reb']);
          }
        } else {
          throw new \Exception("Email template cannot be empty", 1);
        }
      }
    } catch (\Throwable $th) {
      error_log($th);
    }
    return parent::get_content_html();
  }
}
