<?php

namespace Freshmail\FmDesigner;

use Freshmail\FmDesigner\FmDesigner;
use Freshmail\Core\Api\Endpoints\Templates;

class TemplateRetriever
{
  private ?FmDesigner $fmDesigner = null;
  private ?Templates $templates = null;

  public function __construct(FmDesigner $fmDesigner)
  {
    $this->fmDesigner = $fmDesigner;
    $this->templates = createClass('Freshmail\Core\Api\Endpoints\Templates', [$this->fmDesigner->getApiConfig()]);
  }

  public function fmDesigner(): FmDesigner
  {
    return $this->fmDesigner;
  }

  public function getEmailTemplateList(): array
  {
    $valuesToReturn = ['wc_default' => __('Default WordPress Email Template', 'freshmail')];

    try {
      if (! empty($this->templates)) {
        $apiData = $this->templates->lists();
        if (! empty($apiData['data'])) {
          foreach ($apiData['data'] as $dataElement) {
            $valuesToReturn[$dataElement['id_hash']] = $dataElement['name'];
          }
        }
      }
    } catch (\Throwable $th) {
      error_log($th);
    }

    return $valuesToReturn;
  }

  public function getEmailTemplateHTML(string $idHash): array
  {
    $returnData = [];
    if ($this->templates) {
      $apiData = $this->templates->template($idHash);
      if (! empty($apiData['data'])) {
        $returnData = $apiData['data'];
      }
    }
    return $returnData;
  }
}
