<?php

namespace Freshmail\FollowUp\Types\Birthday;

use Freshmail\FollowUp\Settings;

class AccountForm
{
  private string $fieldPrefix = 'account';

  private ?Settings $settings = null;

  public function __construct(Settings $settings)
  {
    $this->settings = $settings;
  }

  /**
   * @action woocommerce_save_account_details
   */
  public function saveForm(int $userID): void
  {
    if ($this->settings->isProfileBirthdayFieldEnabled()) {
      $field = "{$this->fieldPrefix}_birthday";
      if (isset($_POST[$field])) {
        update_user_meta($userID, $field, sanitize_text_field($_POST[$field]));
      }
    }
  }

  /**
   * @action woocommerce_edit_account_form
   */
  public function addBirtdayDate(): void
  {
    if ($this->settings->isProfileBirthdayFieldEnabled()) {
      woocommerce_form_field("{$this->fieldPrefix}_birthday", [
        'type' => 'date',
        'required' => false,
        'label' => __('Birthday date', 'freshmail'),
      ], get_user_meta(get_current_user_id(), "{$this->fieldPrefix}_birthday", true));
    }
  }
}
