<?php

namespace Freshmail\FollowUp\Types\Birthday;

class DataLoader
{
  public function getBirthdayAccounts(): array
  {
    $args = [
      'meta_query' => [
        [
          'key' => 'account_birthday',
          'value' => date('m-d'),
          'compare' => 'LIKE'
        ]
      ],
      'number' => -1
    ];

    $userIDs = array_map(function (\WP_User $user) {
      return $user->ID;
    }, get_users($args));

    return apply_filters('fm/followup/birthday/get_birthday_accounts', $userIDs);
  }
}
